;==================================
; Dekonwolucja (Lucy):
;==================================

; Ustawienie wyswietalnia kolorow
Device, Get_Visual_Depth = thisDepth
IF thisDepth GT 8 THEN Device, Decomposed = 0


; UWAGA - tablica do dekonowlucji musi byc KWADRATOWA
; WCZYTANIE DANYCH - TABLICA ORYGINALNA:

a=fltarr(500,500)
openr,1,'m134224f_15_FLT_500_500.dat'
readf,1,a
close,1
help,a

sa=size(a)
print,sa
;stop

loadct,3
window,0,xs=sa(1),ys=sa(2)
tvscl,a
loadct,0
;a50=a(150-25:150+24,213-25:213+24)
a50=a(125:174,188:237)
sa50=size(a50)




; PARAMETRY DEKONWOLUCJI:

szer = 2.9     ; FWHM
nk   = 3.0     ; podzial na subpiksele => DOZWOLONE: 1, 3 lub 5
warunek = 0.35 ;0.95;0.05 ; zakonczenie dek.



; DEKONWOLUCJA:
dek_lucy_msdp,a50,szer,wynik,nk,warunek

help,wynik
swynik=size(wynik)



; WIZUALIZACJA (TAB_Oryg, TAB_Dek):
; ZAPIS DO PLIKOW:
save,filename='MSDP_dek.sav',wynik
;restore,'MSDP_dek.sav',/verbose

loadct,3
window,10,xs=3*sa50(1),ys=3*sa50(2)
tvscl,rebin(a50,3*sa50(1),3*sa50(2),/SAMPLE)
write_png,'MSDP_Oryginal.png',tvrd(/true)

window,11,xs=swynik(1),ys=swynik(2)
tvscl,wynik
write_png,'MSDP_Dek.png',tvrd(/true)



;wait,2
;;REBIN =>   /sample <=> sample=1
;window,14,xs=10*sa50(1),ys=10*sa50(2),xp=0,yp=0
;tvscl,rebin(a50,10*sa50(1),10*sa50(2),/SAMPLE)
;window,15,xs=10*sa50(1),ys=10*sa50(2),xp=350,yp=0
;tvscl,rebin(a50,10*sa50(1),10*sa50(2))
;window,16,xs=10*sa50(1),ys=10*sa50(2),xp=700,yp=0
;tvscl,rebin(a50,10*sa50(1),10*sa50(2),SAMPLE=1)
loadct,0

print,'End'
end
